
Filename = 'houses_text.png';    % set input file name here
P = 16;                          % Block size for processing (assumed to be even!!)
Image = double(imread(Filename));% Load input image
[H, W, C] = size(Image);         % Image dimensions

%% TASK 2.2
% Detect pixels that need to be inpainted (Mask=0: inpaint, Mask=1: leave untouched)
Mask = zeros(H,W);

% ========================
% ... write code here
% ========================

%%
% set the pixels that need to be inpainted to zero
InpaintedImage = Image .* Mask(:,:,ones(1,1,3));

% Convert to luminance image for block matching (computationally more efficient)
im = to_luminance(InpaintedImage);
square = zeros(H,W);

fig = figure;
step = 1;
counter = 0;
total = sum(sum(Mask==0)); % total number of pixels to inpaint
left = total; % number of pixels left to inpaint

% outer loop
while left>0
    
    % Select region to inpaint in this iteration (1=inpaint, 0=skip)
    Slice = 1-Mask;
    
    % Determine the bounding box of the region that needs to be inpainted
    x_ind = find(sum(Slice,1)>0);
    y_ind = find(sum(Slice,2)>0);
    bounds = [min(x_ind) min(y_ind) max(x_ind) max(y_ind)];
    y_range = bounds(2):step:(bounds(4)+step-1);
    x_range = bounds(1):step:(bounds(3)+step-1);

    % inner loop
    for y = y_range
        for x = x_range            
            % no inpainting at this stage
            if Slice(y,x)==0, 
                continue;
            end;
            
            % in this step we want to reconstruct InpaintedImage(y,x)            
            
            % extract a patch with center (y,x)
            ry = mod(H+(y-P/2:y+P/2-1), H)+1;
            rx = mod(W+(x-P/2:x+P/2-1), W)+1;
            patch = im(ry,rx);
            submask = Mask(ry,rx);

            % no inpainting necessary
            if sum(sum(submask)) == P^2
                continue;
            end;
            
%% Task 2.3
% compute msd = matrix with mean squared differences between 'patch' and each block in the image.
            
            % msd = 

%% 
            % find the best candidate
            [ym,xm] = find(msd==min(min(msd)),1,'first');
                        
            im(y,x) = im(ym,xm);
            InpaintedImage(y,x,:) = InpaintedImage(ym,xm,:);
            Mask(y,x)=1;  Slice(y,x)=0;  % This pixel is no longer assumed to be missing
           
            % show the intermediate results
            if mod(counter,10)==1,      
                % show progress
                left=left-10;
                set(fig,'Name',sprintf('Inpainting program: %.01f%% completed.',100-100*left/total));        
                
                subplot(121), imshow(uint8(InpaintedImage), []); 
                subplot(122), imshow(Slice,[]);                
                uiwait(fig, 0.05);
            end;
            counter = counter + 1;
        end;
    end;    
    % compute the number of missing pixels left
    left=sum(sum(Mask==0));    
end;

% show the final result
subplot(121), imshow(uint8(InpaintedImage), []); 
subplot(122), imshow(Slice,[]);

